SystemOrganization addCategory: #Unification!
SystemOrganization addCategory: #'Unification-Test'!

!Object methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:46'!
unify: anObject

	^anObject unifyWithNonQuery: self
	! !

!Object methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:46'!
unifyWithNonQuery: anObject

	^self = anObject! !

!Object methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:48'!
unifyWithQuery: anUQuery 

	^anUQuery unifyWithNonQuery: self  ! !

Object subclass: #UQuery
	instanceVariableNames: 'matchResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification'!

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:29'!
match: aSmallInteger 
	self shouldBeImplemented.! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:30'!
matchResult

	^ matchResult! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:48'!
unify: anObject

	^anObject unifyWithQuery: self! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:45'!
unifyWithNonQuery: anObject 

	matchResult := anObject.
	^true! !

TestCase subclass: #UnificatoinTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification-Test'!

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:37'!
testArray1

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ({q1. q2} unify: 'hi').
	self assert: $h equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:42'!
testArray1Reversed

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ('hi' unify: {q1. q2}).
	self assert: $h equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:43'!
testFailByValue

	self deny: (1 unify: 2).! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:29'!
testInteger

	| q |
	q := UQuery new.
	q unify: 1.
	self assert: 1 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:30'!
testInteger2

	| q |
	q := UQuery new.
	q unify: 2.
	self assert: 2 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:41'!
testInteger2Reversed

	| q |
	q := UQuery new.
	2 unify: q.
	self assert: 2 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:39'!
testIntegerReversed

	| q |
	q := UQuery new.
	1 unify: q.
	self assert: 1 equals: q matchResult! !

!SequenceableCollection methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:36'!
unify: aSequenceableCollection

	self size = aSequenceableCollection size ifFalse: [^false].
	1 to: self size do: [:index|  | unificationResult |
		unificationResult := (self at: index) unify: (aSequenceableCollection at: index).
		unificationResult ifFalse: [^false] ].
	^true	! !
